Index: /palm/trunk/SOURCE/microphysics_mod.f90
===================================================================
--- /palm/trunk/SOURCE/microphysics_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/microphysics_mod.f90	(revision 2232)
@@ -1904,12 +2031,17 @@
        INTEGER(iwp) ::  k             !<
 
-       REAL(wp), DIMENSION(nzb:nzt+1) :: sed_qc  !<
+       REAL(wp)                       ::  flag    !< flag to indicate first grid level above surface
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  sed_qc  !<
 
        sed_qc(nzt+1) = 0.0_wp
 
-       DO  k = nzt, nzb_s_inner(j,i)+1, -1
+       DO  k = nzt, nzb+1, -1
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+
           IF ( qc_1d(k) > eps_sb )  THEN
              sed_qc(k) = sed_qc_const * nc_1d(k)**( -2.0_wp / 3.0_wp ) *       &
-                         ( qc_1d(k) * hyrho(k) )**( 5.0_wp / 3.0_wp )
+                         ( qc_1d(k) * hyrho(k) )**( 5.0_wp / 3.0_wp )  * flag
           ELSE
              sed_qc(k) = 0.0_wp
@@ -1918,20 +2050,20 @@
           sed_qc(k) = MIN( sed_qc(k), hyrho(k) * dzu(k+1) * q_1d(k) /          &
                                       dt_micro + sed_qc(k+1)                   &
-                         )
+                         ) * flag
 
           q_1d(k)  = q_1d(k)  + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /      &
-                                hyrho(k) * dt_micro
+                                hyrho(k) * dt_micro * flag
           qc_1d(k) = qc_1d(k) + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /      &
-                                hyrho(k) * dt_micro
+                                hyrho(k) * dt_micro * flag
           pt_1d(k) = pt_1d(k) - ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /      &
-                                hyrho(k) * l_d_cp * pt_d_t(k) * dt_micro
+                                hyrho(k) * l_d_cp * pt_d_t(k) * dt_micro * flag
 
 !
 !--       Compute the precipitation rate of cloud (fog) droplets
           IF ( call_microphysics_at_all_substeps )  THEN
-             prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k) *               &
-                             weight_substep(intermediate_timestep_count)
+             prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k) *                  &
+                              weight_substep(intermediate_timestep_count) * flag
           ELSE
-             prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k)
+             prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k) * flag
           ENDIF
 
@@ -1959,5 +2091,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nzb, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -1966,10 +2098,16 @@
            ONLY:  weight_substep
 
+       USE surface_mod,                                                        &
+           ONLY :  bc_h
+       
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i                          !<
-       INTEGER(iwp) ::  j                          !<
-       INTEGER(iwp) ::  k                          !<
-       INTEGER(iwp) ::  k_run                      !<
+       INTEGER(iwp) ::  i             !< running index x direction
+       INTEGER(iwp) ::  j             !< running index y direction
+       INTEGER(iwp) ::  k             !< running index z direction
+       INTEGER(iwp) ::  k_run         !<
+       INTEGER(iwp) ::  m             !< running index surface elements
+       INTEGER(iwp) ::  surf_e        !< End index of surface elements at (j,i)-gridpoint
+       INTEGER(iwp) ::  surf_s        !< Start index of surface elements at (j,i)-gridpoint
 
        REAL(wp)     ::  c_run                      !<
@@ -1979,4 +2117,5 @@
        REAL(wp)     ::  dr                         !<
        REAL(wp)     ::  flux                       !<
+       REAL(wp)     ::  flag                       !< flag to indicate first grid level above surface
        REAL(wp)     ::  lambda_r                   !<
        REAL(wp)     ::  mu_r                       !<
@@ -1994,5 +2133,9 @@
 !
 !--    Compute velocities
-       DO  k = nzb_s_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+
           IF ( qr_1d(k) > eps_sb )  THEN
 !
@@ -2013,5 +2156,5 @@
                                             ( mu_r + 1.0_wp ) )                &
                                         )                                      &
-                          )
+                          ) * flag
              w_qr(k) = MAX( 0.1_wp, MIN( 20.0_wp,                              &
                                          a_term - b_term * ( 1.0_wp +          &
@@ -2019,5 +2162,5 @@
                                             ( mu_r + 4.0_wp ) )                &
                                        )                                       &
-                          )
+                          ) * flag
           ELSE
              w_nr(k) = 0.0_wp
@@ -2026,16 +2169,37 @@
        ENDDO
 !
-!--    Adjust boundary values
-       w_nr(nzb_s_inner(j,i)) = w_nr(nzb_s_inner(j,i)+1)
-       w_qr(nzb_s_inner(j,i)) = w_qr(nzb_s_inner(j,i)+1)
+!--    Adjust boundary values using surface data type. 
+!--    Upward facing non-natural
+       surf_s = bc_h(0)%start_index(j,i)   
+       surf_e = bc_h(0)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k         = bc_h(0)%k(m)
+          w_nr(k-1) = w_nr(k)
+          w_qr(k-1) = w_qr(k)
+       ENDDO
+!
+!--    Downward facing non-natural
+       surf_s = bc_h(1)%start_index(j,i)   
+       surf_e = bc_h(1)%end_index(j,i)
+       DO  m = surf_s, surf_e
+          k         = bc_h(1)%k(m)
+          w_nr(k+1) = w_nr(k)
+          w_qr(k+1) = w_qr(k)
+       ENDDO
+!
+!--    Neumann boundary condition at model top
        w_nr(nzt+1) = 0.0_wp
        w_qr(nzt+1) = 0.0_wp
 !
 !--    Compute Courant number
-       DO  k = nzb_s_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+
           c_nr(k) = 0.25_wp * ( w_nr(k-1) + 2.0_wp * w_nr(k) + w_nr(k+1) ) *   &
-                    dt_micro * ddzu(k)
+                    dt_micro * ddzu(k) * flag
           c_qr(k) = 0.25_wp * ( w_qr(k-1) + 2.0_wp * w_qr(k) + w_qr(k+1) ) *   &
-                    dt_micro * ddzu(k)
+                    dt_micro * ddzu(k) * flag
        ENDDO
 !
@@ -2043,5 +2207,9 @@
        IF ( limiter_sedimentation )  THEN
 
-          DO k = nzb_s_inner(j,i)+1, nzt
+          DO k = nzb+1, nzt
+!
+!--          Predetermine flag to mask topography
+             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+
              d_mean = 0.5_wp * ( qr_1d(k+1) - qr_1d(k-1) )
              d_min  = qr_1d(k) - MIN( qr_1d(k+1), qr_1d(k), qr_1d(k-1) )
@@ -2050,5 +2218,5 @@
              qr_slope(k) = SIGN(1.0_wp, d_mean) * MIN ( 2.0_wp * d_min,        &
                                                         2.0_wp * d_max,        &
-                                                        ABS( d_mean ) )
+                                                        ABS( d_mean ) ) * flag
 
              d_mean = 0.5_wp * ( nr_1d(k+1) - nr_1d(k-1) )
@@ -2058,5 +2226,5 @@
              nr_slope(k) = SIGN(1.0_wp, d_mean) * MIN ( 2.0_wp * d_min,        &
                                                         2.0_wp * d_max,        &
-                                                        ABS( d_mean ) )
+                                                        ABS( d_mean ) ) * flag
           ENDDO
 
@@ -2072,7 +2240,10 @@
 !
 !--    Compute sedimentation flux
-       DO  k = nzt, nzb_s_inner(j,i)+1, -1
-!
-!--       Sum up all rain drop number densities which contribute to the flux
+       DO  k = nzt, nzb+1, -1
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
+!
+!--       Sum up all rain drop number densities which contribute to the flux 
 !--       through k-1/2
           flux  = 0.0_wp
@@ -2083,8 +2254,8 @@
              flux  = flux + hyrho(k_run) *                                     &
                      ( nr_1d(k_run) + nr_slope(k_run) * ( 1.0_wp - c_run ) *   &
-                     0.5_wp ) * c_run * dzu(k_run)
-             z_run = z_run + dzu(k_run)
-             k_run = k_run + 1
-             c_run = MIN( 1.0_wp, c_nr(k_run) - z_run * ddzu(k_run) )
+                     0.5_wp ) * c_run * dzu(k_run) * flag
+             z_run = z_run + dzu(k_run)            * flag
+             k_run = k_run + 1                     * flag
+             c_run = MIN( 1.0_wp, c_nr(k_run) - z_run * ddzu(k_run) ) * flag
           ENDDO
 !
@@ -2094,7 +2265,7 @@
                       hyrho(k) * dzu(k+1) * nr_1d(k) + sed_nr(k+1) * dt_micro )
 
-          sed_nr(k) = flux / dt_micro
+          sed_nr(k) = flux / dt_micro * flag
           nr_1d(k)  = nr_1d(k) + ( sed_nr(k+1) - sed_nr(k) ) * ddzu(k+1) /     &
-                                    hyrho(k) * dt_micro
+                                    hyrho(k) * dt_micro * flag
 !
 !--       Sum up all rain water content which contributes to the flux
@@ -2109,8 +2280,8 @@
              flux  = flux + hyrho(k_run) *                                     &
                      ( qr_1d(k_run) + qr_slope(k_run) * ( 1.0_wp - c_run ) *   &
-                     0.5_wp ) * c_run * dzu(k_run)
-             z_run = z_run + dzu(k_run)
-             k_run = k_run + 1
-             c_run = MIN( 1.0_wp, c_qr(k_run) - z_run * ddzu(k_run) )
+                     0.5_wp ) * c_run * dzu(k_run) * flag
+             z_run = z_run + dzu(k_run)            * flag
+             k_run = k_run + 1                     * flag
+             c_run = MIN( 1.0_wp, c_qr(k_run) - z_run * ddzu(k_run) ) * flag
 
           ENDDO
@@ -2120,19 +2291,19 @@
                       hyrho(k) * dzu(k) * qr_1d(k) + sed_qr(k+1) * dt_micro )
 
-          sed_qr(k) = flux / dt_micro
+          sed_qr(k) = flux / dt_micro * flag
 
           qr_1d(k) = qr_1d(k) + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /      &
-                                hyrho(k) * dt_micro
+                                hyrho(k) * dt_micro * flag
           q_1d(k)  = q_1d(k)  + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /      &
-                                hyrho(k) * dt_micro
+                                hyrho(k) * dt_micro * flag
           pt_1d(k) = pt_1d(k) - ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /      &
-                                hyrho(k) * l_d_cp * pt_d_t(k) * dt_micro
+                                hyrho(k) * l_d_cp * pt_d_t(k) * dt_micro * flag
 !
 !--       Compute the rain rate
           IF ( call_microphysics_at_all_substeps )  THEN
              prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k)                    &
-                          * weight_substep(intermediate_timestep_count)
+                          * weight_substep(intermediate_timestep_count) * flag
           ELSE
-             prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k)
+             prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k) * flag
           ENDIF
 
@@ -2162,13 +2333,19 @@
 
        USE indices,                                                            &
-           ONLY:  nzb_s_inner
+           ONLY:  nzb, nzt, wall_flags_0
 
        USE kinds
 
+       USE surface_mod,                                                        &
+           ONLY :  bc_h
+
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i                          !:
-       INTEGER(iwp) ::  j                          !:
-
+       INTEGER(iwp) ::  i             !< running index x direction
+       INTEGER(iwp) ::  j             !< running index y direction
+       INTEGER(iwp) ::  k             !< running index z direction
+       INTEGER(iwp) ::  m             !< running index surface elements
+       INTEGER(iwp) ::  surf_e        !< End index of surface elements at (j,i)-gridpoint
+       INTEGER(iwp) ::  surf_s        !< Start index of surface elements at (j,i)-gridpoint
 
        IF ( ( dt_do2d_xy - time_do2d_xy ) < precipitation_amount_interval .AND.&
@@ -2177,7 +2354,12 @@
        THEN
 
-          precipitation_amount(j,i) = precipitation_amount(j,i) +              &
-                                      prr(nzb_s_inner(j,i)+1,j,i) *            &
-                                      hyrho(nzb_s_inner(j,i)+1) * dt_3d
+          surf_s = bc_h(0)%start_index(j,i)   
+          surf_e = bc_h(0)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k                         = bc_h(0)%k(m)
+             precipitation_amount(j,i) = precipitation_amount(j,i) +           &
+                                               prr(k,j,i) * hyrho(k) * dt_3d
+          ENDDO
+
        ENDIF
 
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 2231)
+++ /palm/trunk/SOURCE/modules.f90	(revision 2232)
@@ -20,5 +20,24 @@
 ! Current revisions:
 ! ------------------
-! 
+! Renamed wall_flags_0 and wall_flags_00 into advc_flags_1 and advc_flags_2, 
+! respectively. Moreover, introduced further flag array wall_flags_0. 
+!
+! Adjustments for new topography concept:
+!   -fwxm, fwxp, fwym, fwyp, fxm, fxp, fym, fyp, rif_wall, wall_e_x, wall_e_y, 
+!   -wall_v, wall_u, wall_w_x, wall_w_y, wall_qflux, wall_sflux, wall_nrflux, 
+!   -wall_qrflux
+!
+! Adjustments for new surface concept:
+!   +land_surface
+!   -z0, z0h, z0q, us, ts, qs, qsws, nrs, nrsws, qrs, qrsws, ssws, ss, saswsb 
+!   -nzb_diff_u, nzb_diff_v, nzt_diff
+!   -uswst, vswst, tswst, sswst, saswst, qswst, qrswst, nrswst, qswst_remote
+!
+! Generic tunnel setup:
+!   +tunnel_height, tunnel_length, tunnel_width_x, tunnel_width_y, 
+!   +tunnel_wall_depth
+!
+! Topography input via netcdf
+!   +lod
 ! 
 ! Former revisions:
@@ -534,8 +553,4 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f3_mg                 !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  mean_inflow_profiles  !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  nrs                   !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  nrsws                 !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  nrswst                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ol                    !< Obukhov length 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_amount  !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_rate    !< 
@@ -543,17 +558,4 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pt_slope_ref          !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qnudge                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qs                    !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qsws                  !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qswst                 !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qswst_remote          !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qrs                   !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qrsws                 !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qrswst                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  saswsb                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  saswst                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  shf                   !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ss                    !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ssws                  !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sswst                 !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tnudge                !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_lsa_lpt            !< 
@@ -563,20 +565,10 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_a            !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_o            !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ts                    !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tswst                 !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ug_vert               !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  unudge                !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  us                    !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  usws                  !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  uswst                 !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vnudge                !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vg_vert               !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vsws                  !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vswst                 !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wnudge                !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wsubs_vert            !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z0                    !< roughness length for momentum
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z0h                   !< roughness length for heat
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z0q                   !< roughness length for moisture
     
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  d          !< 
@@ -744,5 +736,4 @@
 #endif
 
-    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  rif_wall !< 
     REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  tri      !< 
 
@@ -1014,4 +1005,5 @@
     INTEGER(iwp) ::  io_blocks = 1                     !< 
     INTEGER(iwp) ::  iran = -1234567                   !< 
+    INTEGER(iwp) ::  lod = 1                           !< level of detail, topography input parameter 
     INTEGER(iwp) ::  masks = 0                         !< 
     INTEGER(iwp) ::  maximum_grid_level                !< 
@@ -1130,4 +1122,5 @@
     LOGICAL ::  large_scale_forcing = .FALSE.                !< 
     LOGICAL ::  large_scale_subsidence = .FALSE.             !< 
+    LOGICAL ::  land_surface = .FALSE.                       !< flag parameter indicating wheather the lsm is used
     LOGICAL ::  lsf_exception = .FALSE.                      !< temporary flag for use of lsf with buildings on flat terrain
     LOGICAL ::  lsf_surf = .TRUE.                            !< 
@@ -1183,5 +1176,4 @@
     LOGICAL ::  ws_scheme_sca = .FALSE.                      !< 
     LOGICAL ::  ws_scheme_mom = .FALSE.                      !< 
-
     LOGICAL ::  data_output_xy(0:1) = .FALSE.                !< 
     LOGICAL ::  data_output_xz(0:1) = .FALSE.                !< 
@@ -1322,4 +1314,9 @@
     REAL(wp) ::  top_salinityflux = 9999999.9_wp               !< 
     REAL(wp) ::  top_scalarflux = 9999999.9_wp                 !< 
+    REAL(wp) ::  tunnel_height = 9999999.9_wp                  !< height of tunnel outer wall
+    REAL(wp) ::  tunnel_length = 9999999.9_wp                  !< tunnel length
+    REAL(wp) ::  tunnel_width_x = 9999999.9_wp                 !< tunnel width in x, with respect to outer wall
+    REAL(wp) ::  tunnel_width_y = 9999999.9_wp                 !< tunnel width in y, with respect to outer wall
+    REAL(wp) ::  tunnel_wall_depth = 9999999.9_wp              !< tunnel wall depth
     REAL(wp) ::  ug_surface = 0.0_wp                           !< 
     REAL(wp) ::  u_bulk = 0.0_wp                               !< 
@@ -1366,9 +1363,5 @@
     REAL(wp) ::  wall_heatflux(0:4) = 0.0_wp                       !< 
     REAL(wp) ::  wall_humidityflux(0:4) = 0.0_wp                   !< 
-    REAL(wp) ::  wall_nrflux(0:4) = 0.0_wp                         !< 
-    REAL(wp) ::  wall_qflux(0:4) = 0.0_wp                          !< 
-    REAL(wp) ::  wall_qrflux(0:4) = 0.0_wp                         !< 
     REAL(wp) ::  wall_salinityflux(0:4) = 0.0_wp                   !< 
-    REAL(wp) ::  wall_sflux(0:4) = 0.0_wp                          !< 
     REAL(wp) ::  wall_scalarflux(0:4) = 0.0_wp                     !< 
     REAL(wp) ::  subs_vertical_gradient(10) = 0.0_wp               !< 
@@ -1534,18 +1527,4 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddy2_mg  !< 
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fwxm        !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fwxp        !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fwym        !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fwyp        !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fxm         !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fxp         !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fym         !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fyp         !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wall_e_x    !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wall_e_y    !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wall_u      !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wall_v      !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wall_w_x    !< 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wall_w_y    !< 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zu_s_inner  !<  
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw_w_inner  !< 
@@ -1594,5 +1573,4 @@
     INTEGER(iwp) ::  nzb_max      !< 
     INTEGER(iwp) ::  nzt          !< 
-    INTEGER(iwp) ::  nzt_diff     !< 
 
     INTEGER(idp), DIMENSION(:), ALLOCATABLE ::  ngp_3d        !< 
@@ -1612,6 +1590,4 @@
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_diff_s_inner  !< 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_diff_s_outer  !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_diff_u        !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_diff_v        !< 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_inner         !< 
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_outer         !< 
@@ -1627,7 +1603,4 @@
     INTEGER(iwp), DIMENSION(:,:,:), POINTER ::  flags  !<
 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_0   !< 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_00  !< 
-
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_1   !< 
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_2   !< 
@@ -1641,6 +1614,7 @@
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_10  !< 
 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rflags_s_inner  !< 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rflags_invers   !< 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_1            !< flags used to degrade order of advection scheme
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_2            !< flags used to degrade order of advection scheme
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_0            !< flags to mask topography
 
     SAVE
